# coding: utf-8

"""
    Airtable API

    OpenAPI spec for Airtable's REST API  # noqa: E501

    OpenAPI spec version: 2024-12-27
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TableModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'primary_field_id': 'str',
        'name': 'str',
        'description': 'str',
        'fields': 'list[FieldConfigResponse]',
        'views': 'list[TableModelViews]'
    }

    attribute_map = {
        'id': 'id',
        'primary_field_id': 'primaryFieldId',
        'name': 'name',
        'description': 'description',
        'fields': 'fields',
        'views': 'views'
    }

    def __init__(self, id=None, primary_field_id=None, name=None, description=None, fields=None, views=None):  # noqa: E501
        """TableModel - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._primary_field_id = None
        self._name = None
        self._description = None
        self._fields = None
        self._views = None
        self.discriminator = None
        self.id = id
        self.primary_field_id = primary_field_id
        self.name = name
        if description is not None:
            self.description = description
        self.fields = fields
        self.views = views

    @property
    def id(self):
        """Gets the id of this TableModel.  # noqa: E501

        Unique identifier for the table  # noqa: E501

        :return: The id of this TableModel.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TableModel.

        Unique identifier for the table  # noqa: E501

        :param id: The id of this TableModel.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def primary_field_id(self):
        """Gets the primary_field_id of this TableModel.  # noqa: E501

        The first column in the table and every view  # noqa: E501

        :return: The primary_field_id of this TableModel.  # noqa: E501
        :rtype: str
        """
        return self._primary_field_id

    @primary_field_id.setter
    def primary_field_id(self, primary_field_id):
        """Sets the primary_field_id of this TableModel.

        The first column in the table and every view  # noqa: E501

        :param primary_field_id: The primary_field_id of this TableModel.  # noqa: E501
        :type: str
        """
        if primary_field_id is None:
            raise ValueError("Invalid value for `primary_field_id`, must not be `None`")  # noqa: E501

        self._primary_field_id = primary_field_id

    @property
    def name(self):
        """Gets the name of this TableModel.  # noqa: E501

        Name of the table  # noqa: E501

        :return: The name of this TableModel.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this TableModel.

        Name of the table  # noqa: E501

        :param name: The name of this TableModel.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this TableModel.  # noqa: E501

        Optional description of the table  # noqa: E501

        :return: The description of this TableModel.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this TableModel.

        Optional description of the table  # noqa: E501

        :param description: The description of this TableModel.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def fields(self):
        """Gets the fields of this TableModel.  # noqa: E501

        Array of field definitions  # noqa: E501

        :return: The fields of this TableModel.  # noqa: E501
        :rtype: list[FieldConfigResponse]
        """
        return self._fields

    @fields.setter
    def fields(self, fields):
        """Sets the fields of this TableModel.

        Array of field definitions  # noqa: E501

        :param fields: The fields of this TableModel.  # noqa: E501
        :type: list[FieldConfigResponse]
        """
        if fields is None:
            raise ValueError("Invalid value for `fields`, must not be `None`")  # noqa: E501

        self._fields = fields

    @property
    def views(self):
        """Gets the views of this TableModel.  # noqa: E501

        Array of view configurations  # noqa: E501

        :return: The views of this TableModel.  # noqa: E501
        :rtype: list[TableModelViews]
        """
        return self._views

    @views.setter
    def views(self, views):
        """Sets the views of this TableModel.

        Array of view configurations  # noqa: E501

        :param views: The views of this TableModel.  # noqa: E501
        :type: list[TableModelViews]
        """
        if views is None:
            raise ValueError("Invalid value for `views`, must not be `None`")  # noqa: E501

        self._views = views

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TableModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TableModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
