# coding: utf-8

"""
    Gmail API

    The Gmail API lets you view and manage Gmail mailbox data like threads, messages, and labels.  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ForwardingAddress(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'forwarding_email': 'str',
        'verification_status': 'str'
    }

    attribute_map = {
        'forwarding_email': 'forwardingEmail',
        'verification_status': 'verificationStatus'
    }

    def __init__(self, forwarding_email=None, verification_status=None):  # noqa: E501
        """ForwardingAddress - a model defined in Swagger"""  # noqa: E501
        self._forwarding_email = None
        self._verification_status = None
        self.discriminator = None
        if forwarding_email is not None:
            self.forwarding_email = forwarding_email
        if verification_status is not None:
            self.verification_status = verification_status

    @property
    def forwarding_email(self):
        """Gets the forwarding_email of this ForwardingAddress.  # noqa: E501

        An email address to which messages can be forwarded.  # noqa: E501

        :return: The forwarding_email of this ForwardingAddress.  # noqa: E501
        :rtype: str
        """
        return self._forwarding_email

    @forwarding_email.setter
    def forwarding_email(self, forwarding_email):
        """Sets the forwarding_email of this ForwardingAddress.

        An email address to which messages can be forwarded.  # noqa: E501

        :param forwarding_email: The forwarding_email of this ForwardingAddress.  # noqa: E501
        :type: str
        """

        self._forwarding_email = forwarding_email

    @property
    def verification_status(self):
        """Gets the verification_status of this ForwardingAddress.  # noqa: E501

        Indicates whether this address has been verified and is usable for forwarding. Read-only.  # noqa: E501

        :return: The verification_status of this ForwardingAddress.  # noqa: E501
        :rtype: str
        """
        return self._verification_status

    @verification_status.setter
    def verification_status(self, verification_status):
        """Sets the verification_status of this ForwardingAddress.

        Indicates whether this address has been verified and is usable for forwarding. Read-only.  # noqa: E501

        :param verification_status: The verification_status of this ForwardingAddress.  # noqa: E501
        :type: str
        """
        allowed_values = ["verificationStatusUnspecified", "accepted", "pending"]  # noqa: E501
        if verification_status not in allowed_values:
            raise ValueError(
                "Invalid value for `verification_status` ({0}), must be one of {1}"  # noqa: E501
                .format(verification_status, allowed_values)
            )

        self._verification_status = verification_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ForwardingAddress, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ForwardingAddress):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
