# coding: utf-8

"""
    Gmail API

    The Gmail API lets you view and manage Gmail mailbox data like threads, messages, and labels.  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ListMessagesResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'messages': 'list[Message]',
        'next_page_token': 'str',
        'result_size_estimate': 'int'
    }

    attribute_map = {
        'messages': 'messages',
        'next_page_token': 'nextPageToken',
        'result_size_estimate': 'resultSizeEstimate'
    }

    def __init__(self, messages=None, next_page_token=None, result_size_estimate=None):  # noqa: E501
        """ListMessagesResponse - a model defined in Swagger"""  # noqa: E501
        self._messages = None
        self._next_page_token = None
        self._result_size_estimate = None
        self.discriminator = None
        if messages is not None:
            self.messages = messages
        if next_page_token is not None:
            self.next_page_token = next_page_token
        if result_size_estimate is not None:
            self.result_size_estimate = result_size_estimate

    @property
    def messages(self):
        """Gets the messages of this ListMessagesResponse.  # noqa: E501

        List of messages. Note that each message resource contains only an `id` and a `threadId`. Additional message details can be fetched using the messages.get method.  # noqa: E501

        :return: The messages of this ListMessagesResponse.  # noqa: E501
        :rtype: list[Message]
        """
        return self._messages

    @messages.setter
    def messages(self, messages):
        """Sets the messages of this ListMessagesResponse.

        List of messages. Note that each message resource contains only an `id` and a `threadId`. Additional message details can be fetched using the messages.get method.  # noqa: E501

        :param messages: The messages of this ListMessagesResponse.  # noqa: E501
        :type: list[Message]
        """

        self._messages = messages

    @property
    def next_page_token(self):
        """Gets the next_page_token of this ListMessagesResponse.  # noqa: E501

        Token to retrieve the next page of results in the list.  # noqa: E501

        :return: The next_page_token of this ListMessagesResponse.  # noqa: E501
        :rtype: str
        """
        return self._next_page_token

    @next_page_token.setter
    def next_page_token(self, next_page_token):
        """Sets the next_page_token of this ListMessagesResponse.

        Token to retrieve the next page of results in the list.  # noqa: E501

        :param next_page_token: The next_page_token of this ListMessagesResponse.  # noqa: E501
        :type: str
        """

        self._next_page_token = next_page_token

    @property
    def result_size_estimate(self):
        """Gets the result_size_estimate of this ListMessagesResponse.  # noqa: E501

        Estimated total number of results.  # noqa: E501

        :return: The result_size_estimate of this ListMessagesResponse.  # noqa: E501
        :rtype: int
        """
        return self._result_size_estimate

    @result_size_estimate.setter
    def result_size_estimate(self, result_size_estimate):
        """Sets the result_size_estimate of this ListMessagesResponse.

        Estimated total number of results.  # noqa: E501

        :param result_size_estimate: The result_size_estimate of this ListMessagesResponse.  # noqa: E501
        :type: int
        """

        self._result_size_estimate = result_size_estimate

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ListMessagesResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ListMessagesResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
